<!--
這個檔案是由 Jeffrey Chen a.k.a. legendm33066 (legendm33066@gmail.com) 所撰寫
這個檔案是透過 Creative Commons Attribution-NonCommercial-NoDerivatives 4.0 International License 分享
前往這個網頁以取得更多資訊：http://creativecommons.org/licenses/by-nc-nd/4.0/
-->
<!DOCTYPE html>
<html>
<head>
  <meta charset="UTF-8">
  <title>DrupalUP</title>
  <style>
    body {
      word-wrap: normal;
    }
    .success {
      color: green;
      display: inline;
    }
    .error {
      color: red;
      display: inline;
    }
  </style>
</head>

<body>
<a rel="license" href="http://creativecommons.org/licenses/by-nc-nd/4.0/"><img alt="Creative Commons License" style="border-width:0" src="http://i.creativecommons.org/l/by-nc-nd/4.0/88x31.png" /></a><br />This work is licensed under a <a rel="license" href="http://creativecommons.org/licenses/by-nc-nd/4.0/">Creative Commons Attribution-NonCommercial-NoDerivatives 4.0 International License</a>.
<br />
歡迎使用 DrupalUP，DrupalUP 會自動將您的 Drupal 網站更新到最新版本。
<br />
<div class="error">
DrupalUP 僅會保存 sites 資料夾，您對 .htaccess 或其他檔案所做的更改都不會被保存，並將由新版核心檔案覆蓋，請您務必先行備份。
</div>
<br />
<a href="<?php print $_SERVER['PHP_SELF'] . '?start'; ?>">開始更新</a>
<br />
<?php

function recursive_copy($source, $destination) {
  $directory = opendir($source);
  @mkdir($destination);
  while (($file = readdir($directory)) !== FALSE) {
    if (($file !== '.') && ($file !== '..')) {
      if (is_dir($source . '/' . $file)) {
        recursive_copy($source . '/' . $file, $destination . '/' . $file);
      }
      else {
        copy($source . '/' . $file, $destination . '/' . $file);
      }
    }
  }
  closedir($directory);
}

function recursive_delete($path) {
  if (is_dir($path)) {
    $objects = scandir($path);
    foreach ($objects as $object) {
      if ($object !== '.' && $object !== '..') {
        if (filetype($path . '/' . $object) == 'dir') {
          recursive_delete($path . '/' . $object);
        }
        else {
          unlink($path . '/' . $object);
        }
      }
    }
    reset($objects);
    rmdir($path);
  }
  else {
    unlink($path);
  }
}
if (isset($_GET['start'])) {
  print '正在偵測 Drupal 核心版本⋯⋯';
  define('DRUPAL_BASE_PATH', getcwd());
  define('EXTRACT_PATH', realpath(DRUPAL_BASE_PATH . '/../'));
  define('UPDATE_URL', 'http://updates.drupal.org/release-history/drupal/7.x');
  if (file_exists(DRUPAL_BASE_PATH . '/includes/bootstrap.inc')) {
    require_once DRUPAL_BASE_PATH . '/includes/bootstrap.inc';
    print '<div class="success">' . VERSION . '</div>';
    print '<br />正在搜尋可用更新⋯⋯';
    $project = simplexml_load_string(file_get_contents(UPDATE_URL));
    $version = $project->releases->release[0]->version;
    if ($version > VERSION) {
      print '<div class="success">' . $version . ' 可用</div>';
      $download_link = str_replace('.tar.gz', '.zip', $project->releases->release[0]->download_link);
      print '<br />正在由 ' . $download_link . ' 下載更新⋯⋯';
      $local = EXTRACT_PATH . '/' . basename($download_link);
      if (file_put_contents($local, file_get_contents($download_link)) !== FALSE) {
        print '<div class="success">完成</div>';
        print '<br />正在解壓縮⋯⋯';
        $zip = new ZipArchive;
        $archive = $zip->open($local);
        $zip->extractTo(EXTRACT_PATH);
        $zip->close();
        define('EXTRACTED_DRUPAL', realpath(EXTRACT_PATH . '/drupal-' . $version));
        print '<div class="success">成功</div>';
        print '<br />刪除舊檔案⋯⋯';
        $files = array_diff(scandir(DRUPAL_BASE_PATH), array('.', '..', 'sites'));
        foreach ($files as $file) {
          recursive_delete(DRUPAL_BASE_PATH . '/' . $file);
        }
        print '<div class="success">完成</div>';
        print '<br />複製新檔案⋯⋯';
        recursive_delete(EXTRACTED_DRUPAL . '/sites');
        recursive_copy(EXTRACTED_DRUPAL, DRUPAL_BASE_PATH);
        print '<div class="success">完成</div>';
        print '<br />清理中⋯⋯';
        unlink($local);
        recursive_delete(EXTRACTED_DRUPAL);
        print '<div class="success">完成</div>';
        print '<br />恭喜！DrupalUP 已經將您的 Drupal 網站由 ' . VERSION . ' 升級到 ' . $version . '。您現在可以前往 
          <a href="update.php">update.php</a> 進行資料庫更新（如果有的話）。';
      }
      else {
        print ' <div class="error">失敗</div>';
      }
    }
    else {
      print ' <div class="success">您的 Drupal 已經運行最新版本。</div>';
    }
  }
  else {
    print ' <div class="error">失敗</div>';
  }
}
?>
</body>

</html>
